<html>
<head>
<title>OGRE: OgreParticleSystemRenderer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreParticleSystemRenderer.h</h1><a href="OgreParticleSystemRenderer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE </span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under </span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software </span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later </span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT </span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS </span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with </span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple </span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to </span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ParticleSystemRenderer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ParticleSystemRenderer_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreStringInterface_8h.html">OgreStringInterface.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreFactoryObj_8h.html">OgreFactoryObj.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreRenderQueue_8h.html">OgreRenderQueue.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00043"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html">00043</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParticleSystemRenderer.html" title="Abstract class defining the interface required to be implemented by classes which...">ParticleSystemRenderer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style...">StringInterface</a>
<a name="l00044"></a>00044     {
<a name="l00045"></a>00045     <span class="keyword">public</span>:
<a name="l00047"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#18d83b417a606c9d40f87fffe003ef2a">00047</a>         <a class="code" href="classOgre_1_1ParticleSystemRenderer.html" title="Abstract class defining the interface required to be implemented by classes which...">ParticleSystemRenderer</a>() {}
<a name="l00049"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#cedd9af6338bc40603a571333be5f5f9">00049</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ParticleSystemRenderer.html" title="Abstract class defining the interface required to be implemented by classes which...">ParticleSystemRenderer</a>() {}
<a name="l00050"></a>00050 
<a name="l00052"></a>00052         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getType(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00053"></a>00053 
<a name="l00059"></a>00059         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue, 
<a name="l00060"></a>00060             std::list&lt;Particle*&gt;&amp; currentParticles, <span class="keywordtype">bool</span> cullIndividually) = 0;
<a name="l00061"></a>00061 
<a name="l00063"></a>00063         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setMaterial(<a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat) = 0;
<a name="l00065"></a>00065         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyCurrentCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) = 0;
<a name="l00067"></a>00067         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyAttached(<a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* parent, <span class="keywordtype">bool</span> isTagPoint = <span class="keyword">false</span>) = 0;
<a name="l00069"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#135d07c57490da7dccb849e0058c2b24">00069</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParticleRotated(<span class="keywordtype">void</span>) {}
<a name="l00071"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#7d780e51ef230c6e00e53ca6b0f0f3f6">00071</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParticleResized(<span class="keywordtype">void</span>) {}
<a name="l00073"></a>00073         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParticleQuota(<span class="keywordtype">size_t</span> quota) = 0;
<a name="l00075"></a>00075         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyDefaultDimensions(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height) = 0;
<a name="l00077"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#ec55835fcde21e77487cfbb20f439944">00077</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParticleEmitted(<a class="code" href="classOgre_1_1Particle.html" title="Class representing a single particle instance.">Particle</a>* particle) {}
<a name="l00079"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#64ca1a8e9f77c857d2ffdab29fbdd598">00079</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParticleExpired(<a class="code" href="classOgre_1_1Particle.html" title="Class representing a single particle instance.">Particle</a>* particle) {}
<a name="l00081"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#692f2b1bf819aeb19899df090b241dd8">00081</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParticleMoved(std::list&lt;Particle*&gt;&amp; currentParticles) {}
<a name="l00083"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#9dd8a77610f129937836c371fc37e08a">00083</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyParticleCleared(std::list&lt;Particle*&gt;&amp; currentParticles) {}
<a name="l00091"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#76d2732e63a02c925cca738e1d55b7e9">00091</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ParticleVisualData.html" title="Abstract class containing any additional data required to be associated with a particle...">ParticleVisualData</a>* _createVisualData(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> 0; }
<a name="l00099"></a><a class="code" href="classOgre_1_1ParticleSystemRenderer.html#ddc7a41c0c6aba115a7ca23219001690">00099</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _destroyVisualData(<a class="code" href="classOgre_1_1ParticleVisualData.html" title="Abstract class containing any additional data required to be associated with a particle...">ParticleVisualData</a>* vis) { assert (vis == 0); }
<a name="l00100"></a>00100 
<a name="l00104"></a>00104         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRenderQueueGroup(<a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> queueID) = 0;
<a name="l00105"></a>00105 
<a name="l00108"></a>00108         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setKeepParticlesInLocalSpace(<span class="keywordtype">bool</span> keepLocal) = 0;
<a name="l00109"></a>00109 
<a name="l00111"></a>00111         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#73dc0089e326fa37f93a30bf67ba7e3a" title="Sort mode for billboard-set and particle-system.">SortMode</a> _getSortMode(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     };
<a name="l00114"></a>00114 
<a name="l00116"></a><a class="code" href="classOgre_1_1ParticleSystemRendererFactory.html">00116</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ParticleSystemRendererFactory.html" title="Abstract class definition of a factory object for ParticleSystemRenderer.">ParticleSystemRendererFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1FactoryObj.html" title="Abstract factory class.">FactoryObj</a>&lt;ParticleSystemRenderer&gt;
<a name="l00117"></a>00117     {
<a name="l00118"></a>00118     <span class="keyword">public</span>:
<a name="l00119"></a>00119         <span class="comment">// No methods, must just override all methods inherited from FactoryObj</span>
<a name="l00120"></a>00120     };
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:53 2008
</p>
</body>
</html>
